## ros-indigo-libsegwayrmp 0.2.10

=== CMakeLists.txt ===
## Project Setup
cmake_minimum_required(VERSION 2.6)

project(segwayrmp)
set (segwayrmp_VERSION_MAJOR 0)
set (segwayrmp_VERSION_MINOR 2)
set (segwayrmp_VERSION_PATCH 8)
set (segwayrmp_VERSION
  "${segwayrmp_VERSION_MAJOR}.${segwayrmp_VERSION_MINOR}.${segwayrmp_VERSION_PATCH}")

## Configurations

include(cmake/segwayrmp_settings.cmake)

## Configure the build system

# Add the include folder to the include path
include_directories(${PROJECT_SOURCE_DIR}/include)

# Find boost
find_package(Boost COMPONENTS system thread REQUIRED)
link_directories(${Boost_LIBRARY_DIRS})
include_directories(${Boost_INCLUDE_DIRS})

# Set the source files, headers, and link libraries
set(SEGWAYRMP_SRCS src/segwayrmp.cc src/impl/rmp_io.cc)
set(SEGWAYRMP_HEADERS include/segwayrmp/segwayrmp.h)
set(SEGWAYRMP_LINK_LIBS ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})

# Configure Serial support
include(cmake/segwayrmp_serial.cmake)

# Configure FTD2XX support
include(cmake/segwayrmp_ftd2xx.cmake)

# Configure Graphical User Interface
include(cmake/segwayrmp_gui.cmake)

## Build the segwayrmp project

# Compile the Library
add_library(segwayrmp ${SEGWAYRMP_SRCS})
target_link_libraries(segwayrmp ${SEGWAYRMP_LINK_LIBS})

## Build Examples

set(SEGWAYRMP_EXAMPLE_SRCS examples/segwayrmp_example.cc)
set(SEGWAYRMP_EXAMPLE_LINK_LIBS segwayrmp)
include(cmake/segwayrmp_examples.cmake)

## Build Tests

set(SEGWAYRMP_TEST_SRCS tests/segwayrmp_tests.cc)
set(SEGWAYRMP_TEST_LINK_LIBS segwayrmp)
include(cmake/segwayrmp_tests.cmake)

## Setup Install/Uninstall Targets

include(cmake/segwayrmp_targets.cmake)

=== Makefile ===
all: segwayrmp

install:
	cd build && make install

uninstall:
	cd build && make uninstall

segwayrmp:
	@mkdir -p build
	-mkdir -p bin
	cd build && cmake $(CMAKE_FLAGS) -DSEGWAYRMP_BUILD_EXAMPLES=1 ..
ifneq ($(MAKE),)
	cd build && $(MAKE)
else
	cd build && make
endif

clean:
	-cd build && make clean
	rm -rf build bin lib

.PHONY: doc
doc:
	@doxygen doc/Doxyfile
ifeq ($(UNAME),Darwin)
	@open doc/html/index.html
endif

.PHONY: test
test:
	@mkdir -p build
	@mkdir -p bin
	cd build && cmake $(CMAKE_FLAGS) -DSEGWAYRMP_BUILD_TESTS=1 -DSEGWAYRMP_BUILD_EXAMPLES=1 ..
ifneq ($(MAKE),)
	cd build && $(MAKE)
else
	cd build && make
endif
	@if test -e bin/segwayrmp_tests; then bin/segwayrmp_tests; fi

=== debian/changelog ===
ros-indigo-libsegwayrmp (0.2.10-0trusty) trusty; urgency=high

  * The segwayrmp_gui is now installed so it is available from binaries

 -- William Woodall <wjwwood@gmail.com>  Tue, 10 Dec 2013 06:00:00 -0000

ros-indigo-libsegwayrmp (0.2.9-0trusty) trusty; urgency=high

  * Export -ldl on Linux
    Fix a bug where the explicit link against -ldl
    is not exported by the find_package and
    pkg-config files, which causes down stream
    projects to fail to compile.

 -- William Woodall <wjwwood@gmail.com>  Tue, 11 Jun 2013 05:00:00 -0000

ros-indigo-libsegwayrmp (0.2.8-0trusty) trusty; urgency=high

  * Update find_package infrastructure
    * rename to libsegwayrmpConfig.cmake
    * template in the install path for searching
    * Fix logic around _FOUND
    * Search for ftd2xx on Apple also
    * use libsegwayrmp prefix instead of segwayrmp

 -- William Woodall <wjwwood@gmail.com>  Sat, 18 May 2013 05:00:00 -0000

ros-indigo-libsegwayrmp (0.2.7-0trusty) trusty; urgency=high

  * Added Piyush Khandelwal to maintainer list for bloom release updates.
  * Added pkgconfig file generation for linux. This also introduces the need to have a version number inside CMake apart from package.xml. (fixes #8 <https://github.com/segwayrmp/libsegwayrmp/issues/8>)
  * Fixed libftd2xx installation issue on linux. Tested using a direct cmake installation and catkin_make_isolated. Seems to be working fine on 64 bit. (Fixes #7 <https://github.com/segwayrmp/libsegwayrmp/issues/7>)

 -- William Woodall <wjwwood@gmail.com>  Fri, 03 May 2013 05:00:00 -0000

ros-indigo-libsegwayrmp (0.2.6-0trusty) trusty; urgency=high

  * Add missing run_depend on catkin and fix missing link against pthread

 -- William Woodall <wjwwood@gmail.com>  Thu, 18 Apr 2013 05:00:00 -0000

ros-indigo-libsegwayrmp (0.2.5-0trusty) trusty; urgency=high

  * Another missing import of iostream

 -- William Woodall <wjwwood@gmail.com>  Tue, 16 Apr 2013 18:59:00 -0000

ros-indigo-libsegwayrmp (0.2.4-0trusty) trusty; urgency=high

  * Adding missing include of iostream

 -- William Woodall <wjwwood@gmail.com>  Tue, 16 Apr 2013 17:10:00 -0000

ros-indigo-libsegwayrmp (0.2.3-0trusty) trusty; urgency=high

  * Fixed a build bug

 -- William Woodall <wjwwood@gmail.com>  Mon, 21 Jan 2013 02:30:00 -0000

ros-indigo-libsegwayrmp (0.2.2-0trusty) trusty; urgency=high

  * Add buildtool depend on cmake

 -- William Woodall <wjwwood@gmail.com>  Sun, 20 Jan 2013 23:03:00 -0000

ros-indigo-libsegwayrmp (0.2.1-0trusty) trusty; urgency=high

  * Add boost as a dependency
  * Update .travis.yml

 -- William Woodall <wjwwood@gmail.com>  Thu, 17 Jan 2013 23:12:00 -0000

ros-indigo-libsegwayrmp (0.2.0-0trusty) trusty; urgency=high

  * update copyright
  * Readme
  * Linking bug with Boost System
  * Adding travis support
  * Adding GUI dependencies to the package.xml
  * Preparation for release into groovy as 3rdparty
  * Removed ROS specific code
  * Merge pull request #4 <https://github.com/segwayrmp/libsegwayrmp/issues/4> from utexas-bwi/master
    reset all integrators before starting read.
  * reset all integrators before starting read. Prevents the first couple of values from being arbitrary if the integrators are to be reset
  * Updates to the manifest and build system to assist building of dependent packages in ROS.
  * Fixing a compile problem on Linux
  * Inverting commands sent to the segway from the GUI so it turns correctly
  * Added joystick support, and other improvements to the GUI
  * Added the moveCounts function which allows you to command the base using counts rather than approximated velocities
  * Cleaning up build system
  * Added a cancel function to rmp_io to fix a bug where the library would hang on disconnect if the device was shutdown before disconnecting
  * Moved the enumerateUSBDevices function out of the ftd2xx_rmp_io class so it could be used by the GUI.
  * Disable the copy constructors.
  * Adding Graphical User Interface which is useful for configuring the Segway and validating the SegwayRMP library.
  * Removing sublime-workspace file
  * Adding .cc extension files and other missing files.
  * Modified the connect method to no longer explicitly set the operational mode and controller gains as these are saved between segway restarts and should be a one time configuration or explicit mode request.  Additionally added a shutdown command which sends the previously unimplemented "RMP shutdown message".  This involved making the rmp_io class respect the packet.id value.
  * Changed the way the Serial dependency is searched for.  If it is not found with find_package and the ROS_ROOT environment variable is set then it tries to find the serial library using rosbuild.
  * Ignore CMakeLists.txt.user from Qt Creator.
  * Tested working in tractor mode.
  * Fixing a serial cmake typo
  * Major changes to layout and code base, compiles, but needs testing.
  * Merge pull request #2 <https://github.com/segwayrmp/libsegwayrmp/issues/2> from piyushk/master
    remove deadlock in libsegwayrmp.git
  * fixed deadlock in ConcurrentQueue when cancelled -- allows libsegwayrmp to terminate gracefully
  * Update README.markdown
  * Adding #include <boost/function.hpp> reported by Manuel Wopfner, Thanks.
  * Update include/impl/rmp_serial.h
  * Fixing queueing bug.
  * Fixing a bug reported by ilan.
  * Adding a concurrent queue for processing segwaystatus structures via the user callback, this should allow some flexibility.
  * Updated the change log.
  * Updating documentation.  I think we are ready for rc2.
  * Changed callbacks to use Boost Function typedefs so now you can use Boost Bind to use class methods as callbacks.
    Updated the documentation to reflect the new Boost::bind method of class method callbacks.
    Added a Timestamp callback to allow users to manage time stamping.
    Added an Exception handling callback so users can handle otherwise unhanded exceptions that might occur in the internal library threads.


=== debian/control ===
Source: ros-indigo-libsegwayrmp
Section: misc
Priority: extra
Maintainer: William Woodall <wjwwood@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libqt4-dev, libsdl1.2-dev, ros-indigo-serial
Homepage: http://segwayrmp.github.com/libsegwayrmp/
Standards-Version: 3.9.2

Package: ros-indigo-libsegwayrmp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libqt4-dbus, libqt4-network, libqt4-script, libqt4-test, libqt4-xml, libqtcore4, libsdl1.2-dev, ros-indigo-catkin, ros-indigo-serial
Description: This is a C++ library for interfacing with Segway's RMP line of robotic platforms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-libsegwayrmp//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
